#include<iostream>
#include<vector>
using namespace std;
int n, q, redica[10000], helper[10000];
const int MAXN = 2000000;
vector<int> prosti;
bool namacano[MAXN + 10];

void eratosten(){
    for(int i = 0; i <= MAXN; ++i){ namacano[i] = false;}
    for(int i = 2; i <= MAXN; ++i){
        for(int j = i * 2; j <= MAXN; j += i){
            namacano[j] = true;
        }
    }
    for(int i = 2; i <= MAXN; ++i){
        if(!namacano[i]){
            prosti.push_back(i);
        }
    }
}

void input(){
    cin >> n >> q;
    for(int i = 0; i < n; ++i){
        cin >> redica[i];
    }
}

void maloumno_reshenie(){
    int ans = 0;
    bool debug = false;
    for(auto prosto : prosti){
        if(debug) cout << prosto << ": ";
        for(int i = 0; i < n; ++i){ // obhozdame vsichki chisla
            helper[i] = 0;
            while(redica[i] % prosto == 0){
                helper[i]++;
                redica[i] /= prosto;
            }
            if(debug) cout << helper[i] << " ";
        }
        if(debug) cout << endl;
        bool found_non_zero = true;
        int minimum, starti;
        while(found_non_zero){
            found_non_zero = false;
            for(int i = 0; i < n; ++i){
                if(!found_non_zero && helper[i] > 0){
                    found_non_zero = true;
                    minimum = helper[i];
                    starti = i;
                }else if(found_non_zero){
                    if(helper[i] == 0){
                        i = n;
                    }else{
                        minimum = min(minimum, helper[i]);
                    }
                }
            }
            if(debug){
                cout << minimum << " ";
                for(int i = 0; i < n; ++i){
                    cout << helper[i] << " ";
                }
            }
            if(found_non_zero){
                for(int i = starti; i < n; ++i){
                    if(helper[i] - minimum >= 0){
                        helper[i] -= minimum;
                    }else{
                        i = n;
                    }
                }
                ans += minimum;
                if(debug) cout << "+";
            }
            if(debug) cout << endl;
        }
    }
    cout << ans;
}
int main(){
    input();
    eratosten();
    if(q != 0) return 0;
    maloumno_reshenie();
    return 0;
}
/*
aiming for podzadacha 4
n <= 5000
q = 0
*/
