# include <iostream>
# include <vector>
using namespace std;

const int MAXP=2e6+11,MAX=5e5+11;
int lp[MAXP];
vector<int> pr;

void Sieve()
{
    for(int i=2;i<MAXP;i++)
    {
        if(lp[i]==0)
        {
            for(int j=i;j<MAXP;j+=i) lp[j]=i;
        }
    }

    //for(int i=2;i<=64;i++) cout<<i<<":"<<lp[i]<<"\n";
    //cout<<pr.size()<<"\n";
}

int a[MAX];
int brd[MAXP];
int used[MAX];
int n,q;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    Sieve();

    cin>>n>>q;
    for(int i=1;i<=n;i++) cin>>a[i];

    int ans=0;
    for(int i=1;i<=n;i++)
    {
        int x=a[i];
        int d=lp[x], br=0;
        while(x>1)
        {
            //cout<<x<<" ";

            if(lp[x]==d) br++;
            else
            {
                if(used[d]!=i) brd[d]=0;
                if(brd[d]<br) ans+=br-brd[d];

                used[d]=i+1;
                brd[d]=br;
                d=lp[x];
                br=1;
            }

            x/=d;
        }
        //cout<<"\n";

        if(used[d]!=i) brd[d]=0;
        if(brd[d]<br) ans+=br-brd[d];
        brd[d]=br;
        used[d]=i+1;
    }

    cout<<ans<<"\n";

    return 0;
}
