# include <iostream>
# include <vector>
# include <set>
# include <tuple>
# include <utility>
using namespace std;

const int MAXP=2e6+11,MAX=5e5+11;
int lp[MAXP];
vector<int> pr;

void Sieve()
{
    for(int i=2;i<MAXP;i++)
    {
        if(lp[i]==0)
        {
            for(int j=i;j<MAXP;j+=i) lp[j]=i;
        }
    }

    //for(int i=2;i<=64;i++) cout<<i<<":"<<lp[i]<<"\n";
    //cout<<pr.size()<<"\n";
}

int a[MAX];
set<pair<int, int>> s[MAXP];
int ans=0;
int n,q;

int get_ans(int k, int id, int val) ///rabotobachka
{
    auto it=s[k].find({id,val});
    if(it==s[k].begin()) return val;

    int pr=0;
    it--;
    if(it->first==id-1) pr=it->second;

    if(pr>=val) return 0;
    else return val-pr;
}

void rem(int k, int id, int val)
{
    //cout<<"Rem:"<<k<<" "<<id<<" "<<val<<"\n";

    int curr_ans=0;
    auto it=s[k].find({id,val});

    curr_ans-=get_ans(k,id,val);
    auto it2=it;
    if(it!=(--s[k].end()))
    {
        it2++;
        curr_ans-=get_ans(k,it2->first,it2->second);   ///vizh tuka
    }

    pair<int, int> nxt={-1,-1};
    if(it!=(--s[k].end())) nxt=(*it2);
    s[k].erase(it);

    //cout<<nxt.first<<" "<<nxt.second<<"\n";

    if(nxt.first!=-1) curr_ans+=get_ans(k,nxt.first,nxt.second);
    ans+=curr_ans;
}

void add(int k, int id, int val) ///rabotobachka
{
    //cout<<"Add:"<<k<<" "<<id<<" "<<val<<"\n";

    int curr_ans=0;
    s[k].insert({id,val});
    auto it=s[k].find({id,val});
    if(it!=(--s[k].end()))
    {
        pair<int, int> nxt=(*(++it));
        s[k].erase(--it);
        curr_ans-=get_ans(k,nxt.first,nxt.second);
        s[k].insert({id,val});
    }

    //cout<<"->"<<curr_ans<<"\n";

    auto it2=s[k].find({id,val});
    curr_ans+=get_ans(k,id,val);
    //cout<<"->"<<curr_ans<<"\n";
    if(it2!=(--s[k].end())) {it2++;curr_ans+=get_ans(k,it2->first,it2->second);} ///tuka
    //cout<<"->"<<curr_ans<<"\n";
    ans+=curr_ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    Sieve();

    cin>>n>>q;
    for(int i=1;i<=n;i++) cin>>a[i];

    for(int i=1;i<=n;i++)
    {
        int x=a[i];
        int d=lp[x], br=0;
        while(x>1)
        {
            if(lp[x]==d) br++;
            else
            {
                add(d,i,br);
                d=lp[x];
                br=1;
            }

            x/=d;
        }

        add(d,i,br);
    }
    cout<<ans<<"\n";

    while(q--)
    {
        int pos, val;
        cin>>pos>>val;

        int x=a[pos];
        int d=lp[x], br=0;
        while(x>1)
        {
            if(lp[x]==d) br++;
            else
            {
                rem(d,pos,br);
                d=lp[x];
                br=1;
            }

            x/=d;
        }
        rem(d,pos,br);

        //cout<<"after_rem:"<<ans<<"\n";

        a[pos]=val;
        x=a[pos];
        d=lp[x];br=0;
        while(x>1)
        {
            if(lp[x]==d) br++;
            else
            {
                add(d,pos,br);
                d=lp[x];
                br=1;
            }

            x/=d;
        }

        add(d,pos,br);

        cout<<ans<<"\n";

    }

    return 0;
}

