#include <bits/stdc++.h>
using namespace std;

int a[400002], b[400002];
int n, m;

int simulate(int idx, int l, int r, bool allowed) {
    for (int i = idx + 1; i <= m; i++) {
        if (a[l - 1] == i) l--;
        else if (a[r + 1] == i) r++;
        else {
            if (!allowed) return -1;

            int curr_idx = b[i];
            int ans1 = -1, ans2 = -1;

            if (l - 1 > 0) {
                swap(a[curr_idx], a[l - 1]);
                swap(b[i], b[a[l - 1]]);

                ans1 = simulate(i, l - 1, r, 0);

                swap(a[curr_idx], a[l - 1]);
                swap(b[i], b[a[l - 1]]);
            }

            if (r + 1 <= m) {
                swap(a[curr_idx], a[r + 1]);
                swap(b[i], b[a[r + 1]]);

                ans2 = simulate(i, l, r + 1, 0);

                swap(a[curr_idx], a[r + 1]);
                swap(b[i], b[a[r + 1]]);
            }

            if (ans1 == -1 && ans2 == -1) return -1;
            return max(ans1, 0) + max(ans2, 0);
        }
    }

    return !allowed;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    if (n != 1) exit(0);

    for (int i = 1; i <= m; i++) {
        cin >> a[i];
        b[a[i]] = i;
    }

    int ans = -1, ans1 = -1, ans2 = -1, ans3 = -1;

    int curr_idx = b[1], curr_idx2 = b[2];
    if (abs(b[1] - b[2]) == 1) ans = simulate(1, b[1], b[1], 1);

    if (b[2] - 1 > 0 && b[1] != b[2] - 1) {
        swap(a[curr_idx], a[curr_idx2 - 1]);
        swap(b[1], b[a[curr_idx2 - 1]]);

        ans1 = simulate(1, b[1], b[1], 1);

        swap(a[curr_idx], a[curr_idx2 - 1]);
        swap(b[1], b[a[curr_idx2 - 1]]);
    }

    if (b[2] + 1 <= m && b[1] != b[2] + 1) {
        swap(a[curr_idx], a[curr_idx2 + 1]);
        swap(b[1], b[a[curr_idx2 + 1]]);

        ans1 = simulate(1, b[1], b[1], 1);

        swap(a[curr_idx], a[curr_idx2 + 1]);
        swap(b[1], b[a[curr_idx2 + 1]]);
    }

    if (ans != -1 || ans1 != -1 || ans2 != -1) ans3 = max(ans, 0) + max(ans1, 0) + max(ans2, 0) + max(ans3, 0);

    if (ans3 > 0) cout << 1 << ' ';
    if (ans3 == -1) cout << 2 << endl;
    else cout << ans3 << endl;
    return 0;

}
