#include <bits/stdc++.h>
using namespace std;

int sieve[10001];
vector <int> primes;

int get_power(int n, int p) {
    int br = 0;

    while (n % p == 0) {
        n /= p;
        br++;
    }

    return br;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int s, br = 0;
    cin >> s;

    for (int i = 2; i <= s; i++) {
        if (sieve[i]) continue;
        primes.push_back(i);

        for (int j = i; j <= s; j += i) {
            if (sieve[j] == 0) sieve[j] = i;
        }
    }

    for (int i = 1; i <= s; i++) {
        int num = i;

        while (num % 2 == 0) num /= 2;
        if (num % 4 == 3) continue;

        for (int x : primes) {
            if (x > num) break;
            if (x % 4 == 3 && get_power(num, x) % 2 != 0) continue;
        }

        br++;
    }

    cout << br << endl;
    return 0;

}
