#include <bits/stdc++.h>
using namespace std;

int sieve[50000001];
vector <int> primes;

pair <int, int> get_power(int n, int p) {
    int br = 0;

    while (n % p == 0) {
        n /= p;
        br++;
    }

    return {br, n};
}



int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int s, br = 0;
    cin >> s;

    for (int i = 2; i * i <= s; i++) {
        if (sieve[i]) continue;

        for (int j = i; j <= s; j += i) {
            if (sieve[j] == 0) sieve[j] = i;
        }
    }

    for (int i = 1; i <= s; i++) {
        int num = i;

        while (num % 2 == 0) num /= 2;
        if (num % 4 == 3) continue;

        bool f = true;

        /**for (int x : primes) {
            if (x > num) break;
            if (x % 4 == 3 && get_power(num, x).first % 2 != 0) {
                f = 0;
                break;
            }
        }*/

        while (num != 1) {
            int br = 0, sv = sieve[num];
            if (sv == 0) sv = num;

            while (num % sv == 0) {
                num /= sv;
                br++;
            }

            if (sv % 4 == 3 && br % 2 != 0) {
                f = 0;
                break;
            }
        }

        br += f;
    }

    cout << br << endl;
    return 0;

}
