#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXN = 5e5 + 10;
const ll MAXQ = 5e5 + 10;
const ll MAXA = 2e6 + 10;

ll n, q;
ll a[MAXN];
ll lpd[MAXA];

unordered_map < ll, ll > fact[MAXN];
unordered_map < ll, ll > cur;

void read()
{
    cin >> n >> q;
    for(ll i = 1; i <= n; i++)
    {
        cin >> a[i];
    }
}

void sieve()
{
    for(ll i = 2; i < MAXA; i++)
    {
        if(lpd[i])
            continue;

        for(ll j = i; j < MAXA; j += i)
        {
            if(!lpd[j])
                lpd[j] = i;
        }
    }
}

void make_factorization(ll i)
{
    ll val = a[i];

    while(val > 1)
    {
        ll l = lpd[val];
        fact[i][l]++;
        val /= l;
    }
}

void factorize()
{
    for(ll i = 1; i <= n; i++)
    {
       /// cout << endl << "Index : " << i << endl << endl;
        make_factorization(i);
        for(auto it = fact[i].begin(); it != fact[i].end(); it++)
        {
            ll p = it -> first;
            ll cnt = it -> second;

           /// cout << p << " -> " << cnt << endl;
        }
    }
}

void solve()
{
    ll ans = 0;
    for(ll i = 1; i <= n; i++)
    {
        for(auto it = cur.begin(); it != cur.end(); it++)
        {
            ll p = it -> first;

            if(!fact[i][p])
            {
                ans += cur[p];
                cur[p] = 0;
            }
            else
            {
                cur[p] = max(cur[p], fact[i][p]);
            }
        }
        for(auto it = fact[i].begin(); it != fact[i].end(); it++)
        {
            ll p = it -> first;
            ll cnt = it -> second;

            cur[p] = max(cur[p], cnt);
        }
    }
    for(auto it = cur.begin(); it != cur.end(); it++)
    {
        ll p = it -> first;

        if(cur[p])
            ans += cur[p];
    }

    cout << ans << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    sieve();
    factorize();
    solve();

    return 0;
}
