#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXS = 1e8 + 10;

int s;
int ans;
int lpd[MAXS];

void sieve()
{
    for(int i = 2; i <= s; i++)
    {
        if(lpd[i])
            continue;

        for(int j = i; j <= s; j += i)
        {
            if(!lpd[j])
                lpd[j] = i;
        }
    }
}

void read()
{
    cin >> s;
}

void solve()
{
    ans = 1;
    for(int i = 2; i <= s; i++)
    {
        int val = i;
        int cnt = 0;
        int cur = 0;

        bool lampa = true;

        while(val > 1)
        {
            int l = lpd[val];
            if(cur == 0)
            {
                cur = l;
                cnt = 1;
            }
            else if(cur == l)
                cnt++;
            else if(cur != l)
            {
                if(cur % 4 == 3 && cnt % 2 != 0)
                {
                    lampa = false;
                    break;
                }
                cur = l;
                cnt = 1;
            }

            val /= l;
        }
        if(cur % 4 == 3 && cnt % 2 != 0)
            lampa = false;

        if(lampa)
            ans++;
    }
    cout << ans << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    sieve();
    solve();

    return 0;
}
