#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N_max = 5e5 + 1;
const int Q_max = 5e5 + 1;
const int A_max = 2e6 + 2;

int N, Q;
int a[N_max];
int dp[N_max];
int smallestPrime[A_max];

void ER()
{
    for (long long i = 2; 2 * i < A_max; i++)
    {
        if (smallestPrime[i] == 0)
        {
            smallestPrime[i] = i;

            for (long long q = i * i; q < A_max; q += i)
            {
                if (smallestPrime[q] == 0)
                    smallestPrime[q] = i;
            }
        }
    }
}

int brDivs(int l, int r)
{
    unordered_map <int, int> maxMp;

    for (int i = l; i <= r; i++)
    {
        int k = a[i];
        unordered_map <int, int> mp;

        while (k > 1)
        {
            mp[smallestPrime[k]]++;
            maxMp[smallestPrime[k]] = max(maxMp[smallestPrime[k]], mp[smallestPrime[k]]);
            k /= smallestPrime[k];
        }
    }

    int br = 0;

    for (auto c : maxMp)
    {
        br += c.second;
    }

    return br;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> N >> Q;

    for (int i = 1; i <= N; i++)
    {
        cin >> a[i];
    }

    ER();

    dp[1] = brDivs(1, 1);

    for (int i = 2; i <= N; i++)
    {
        dp[i] = dp[i - 1] + brDivs(i, i);

        for (int q = 1; q < i; q++)
        {
            ///cout << "brDivs: " << brDivs(q, i) << " " << q << " " << i << endl;

            dp[i] = min(dp[i], dp[q - 1] + brDivs(q, i));
        }
    }

    cout << dp[N] << endl;

    return 0;
}
