#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N_max = 5e5 + 1;
const int Q_max = 5e5 + 1;
const int A_max = 2e6 + 2;

int N, Q;
int a[N_max];
int dp[N_max];
int smallestPrime[A_max];

void ER()
{
    for (long long i = 2; 2 * i < A_max; i++)
    {
        if (smallestPrime[i] == 0)
        {
            smallestPrime[i] = i;

            for (long long q = i * i; q < A_max; q += i)
            {
                if (smallestPrime[q] == 0)
                    smallestPrime[q] = i;
            }
        }
    }
}

bool check()
{
    for (int i = 1; i <= N; i++)
    {
        if (a[i] > 1)
        {
            return 1;
        }
    }

    return 0;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> N >> Q;

    for (int i = 1; i <= N; i++)
    {
        cin >> a[i];
    }

    ER();

    int br = 0;

    while (check())
    {
        int bestL = -1, bestR = -1;
        int bestNod;

        for (int i = 1; i <= N; i++)
        {
            if (a[i] != 1)
            {
                int nod = a[i], currNod = a[i];
                int currL = i, currR = i;

                for (int q = i + 1; q <= N; q++)
                {
                    nod = __gcd(a[i], a[q]);

                    if (nod == 1)
                    {
                        break;
                    }
                    else
                    {
                        currNod = nod;
                        currR = q;
                    }
                }

                if (currR - currL + 1 >= bestR - bestL + 1)
                {
                    bestL = currL;
                    bestR = currR;
                    bestNod = currNod;
                }
            }
        }

        for (int i = bestL; i <= bestR; i++)
        {
            a[i] /= bestNod;
        }

        /**for (int i = 1; i <= N; i++)
        {
            cout << a[i] << " ";
        }

        cout << endl;**/

        br++;


    }

    cout << br << endl;

    return 0;
}
