#include <iostream>
#include <vector>
using namespace std;
#define maxA 2000000
#define maxN 500000
#define ll long long
int divNum[maxA + 1];
int a[maxN + 1];
int primes[149000];
int n, q, primesCnt = 0;
vector<pair<int, int>> intSt;
vector<pair<int, int>> intEnd;

void createInterval(int idx) {
    for (int i = 0; i < primesCnt; i++) {
        while (a[idx] % primes[i] == 0) {
            for (int j = idx + 1; j <= n; j++) {
                if (j == n || a[j] % primes[i] != 0) {
                    intervalSt.push_back({ idx, i });
                    intervalEnd.push_back({ j -  1, i });
                    break;
                } else {
                    a[j] /= primes[i];
                }
            }
            a[idx] /= primes[i];
        }
    }
}

int gcd(int a, int b) {
    if (b > a) {
        int temp = a;
        a = b;
        b = temp;
    }
    while (b != 0) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

void eratosten() {
    for (int i = 2; i <= maxA; i++) {
        if (divNum[i] == 0) {
            primes[primesCnt++] = i;
            for (int j = i; j <= maxA; j += i) {
                ll num = i;
                while (j % num == 0) {
                    divNum[j]++;
                    num *= i;
                }
            }
        }
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    eratosten();

    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        createInterval(i);
    }
    cout << interval.size() << "\n";
//    for (int i )
}
