#include <iostream>
#include <vector>
using namespace std;
#define maxA 2000000
#define maxN 500000
#define ll long long
#define st first
#define end first
#define val second
int divNum[maxA + 1];
int a[maxN + 1];
int primes[149000];
int n, q, primesCnt = 0;

int gcd(int a, int b) {
    if (a < 0 || b < 0) {
        return -1;
    }
    if (b > a) {
        int temp = a;
        a = b;
        b = temp;
    }
    while (b != 0) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

void eratosten() {
    for (int i = 2; i <= maxA; i++) {
        if (divNum[i] == 0) {
            primes[primesCnt++] = i;
            for (int j = i; j <= maxA; j += i) {
                ll num = i;
                while (j % num == 0) {
                    divNum[j]++;
                    num *= i;
                }
            }
        }
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    eratosten();

    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int ans = divNum[a[0]];
    for (int i = 1; i < n; i++) {
        ans += divNum[a[i]];
        ans -= divNum[gcd(a[i], a[i - 1])];
    }
    cout << ans;
}
