#include <iostream>
#include <bitset>
using namespace std;

bitset<2002> visited[2000002];
int a[2002];
int pos[2002];
int n, m;
int N;

bool checkIfSol(int idx) {
    visited[idx][pos[1]] = 1;
    for (int i = 2; i <= N; i++) {
        if ((pos[i] != 0 && pos[i] % m != 0 && visited[idx][pos[i] - 1]) ||
            (pos[i] != N - 1 && pos[i] % m != m - 1 && visited[idx][pos[i] + 1]) ||
            (pos[i] + m < N && visited[idx][pos[i] + m]) ||
            (pos[i] >= m && visited[idx][pos[i] - m])) {
            visited[idx][pos[i]] = 1;
        } else {
            return 0;
        }
    }
    return 1;
}

int getType(int num) {
    int f = num;
    if (visited[0][f]) {
        return 1;
    }
    if ((f != 0 && f % m != 0 && visited[0][f - 1]) ||
        (f != N - 1 && f % m != m - 1 && visited[0][f + 1]) ||
        (f + m < N && visited[0][f + m]) ||
        (f >= m && visited[0][f - m])) {

        return 2;
    } else {
        return 3;
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    N = n * m;

    for (int i = 0; i < N; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    if (checkIfSol(0)) {
        cout << 0;
        return 0;
    }
    int cnt = 1, ans = 0;
    for (int i = 0; i < N; i++) {
        for (int j = i + 1; j < N; j++) {
            if ((getType(i) == 1 && (getType(j) == 2)) ||
                (getType(i) == 2 && (getType(j) != 2)) ||
                (getType(i) == 3 && (getType(j) == 2)) ||
                a[i] == 1) {

                int temp = pos[a[i]];
                pos[a[i]] = pos[a[j]];
                pos[a[j]] = temp;
                if (checkIfSol(cnt)) {
                    ans++;
                }
                cnt++;
                temp = pos[a[i]];
                pos[a[i]] = pos[a[j]];
                pos[a[j]] = temp;
            }
        }
    }
    if (ans != 0) {
        cout << "1 " << ans;
    } else {
        cout << 2;
    }
}
