#include<iostream>
#include<queue>
using namespace std;
int n, m;
int board[200][200];
int visited[40000], oneIndex;
void input(){
    cin >> n >> m;
    for(int y = 0; y < n; ++y){
        for(int x = 0; x < m; ++x){
            cin >> board[y][x];
            visited[board[y][x]] = 0;
        }
    }
}
bool isSolvable(int a){
    int next = 1;
    for(int y = 0; y < n; ++y){
        for(int x = 0; x < m; ++x){
            if(board[y][x] == 1){
                oneIndex = y * n + x;
                y = n;
                x = m;
            }
        }
    }
    priority_queue<pair<int, int>, std::vector<pair<int, int>>, std::greater< pair<int, int> > > pq;
    pq.push(pair(1, oneIndex));
    while(!pq.empty()){
        int top = pq.top().first, index = pq.top().second;
        pq.pop();
        if(next == top){
            if(index - 1 >= 0){ pq.push({board[0][index - 1], index - 1}); }
            if(index + 1 < m) { pq.push({board[0][index + 1], index + 1}); }
            next++;
        }
    }
    return next == n * m + 1;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    input();
    if(n != 1) return 0;
    if(isSolvable(1)){
        cout << 0;
        return 0;
    }
    int ans = 0;
    for(int i = 0; i < m - 1; ++i){
        for(int j = i + 1; j < m; ++j){
            if(i != j){
                swap(board[0][i], board[0][j]);
                if(isSolvable(1)){
                    ans++;
                }
                swap(board[0][i], board[0][j]);
            }
        }
    }
    if(ans != 0){
        cout << 1 << " " << ans;
        return 0;
    }
    cout << 2;
    return 0;
}
