#include<iostream>
#include<tuple>
#include<queue>
using namespace std;
int n, m;
int board[200][200];
int visited[40000], oneIndex;
void input(){
    cin >> n >> m;
    for(int y = 0; y < n; ++y){
        for(int x = 0; x < m; ++x){
            cin >> board[y][x];
            visited[board[y][x]] = 0;
        }
    }
}
int findMaxReachable(){
    int next = 1, oneY, oneX;
    for(int y = 0; y < n; ++y){
        for(int x = 0; x < m; ++x){
            if(board[y][x] == 1){
                oneY = y;
                oneX = x;
                y = n;
                x = m;
            }
        }
    }
    priority_queue<tuple<int, int, int>, std::vector<tuple<int, int, int>>, std::greater< tuple<int, int, int> > > pq;
    pq.push(std::make_tuple(1, oneY, oneX));
    while(!pq.empty()){
        int top = std::get<0>(pq.top()), topY = std::get<1>(pq.top()), topX = std::get<2>(pq.top());
        pq.pop();
        if(next == top){
            if(topY - 1 >= 0){
                pq.push(std::make_tuple(board[topY - 1][topX], topY - 1, topX));
            }
            if(topY + 1 < n){
                pq.push(std::make_tuple(board[topY + 1][topX], topY + 1, topX));
            }
            if(topX - 1 >= 0){
                pq.push(std::make_tuple(board[topY][topX - 1], topY, topX - 1));
            }
            if(topX + 1 < m){
                pq.push(std::make_tuple(board[topY][topX + 1], topY, topX + 1));
            }
            next++;
        }
    }
    return next;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    input();
    int maxReachable = findMaxReachable() - 1, maxRy, maxRx, maxR1y, maxR1x, ans = 0;
    if(maxReachable == n * m){
        cout << 0;
        return 0;
    }
    // find coordinates of maxR and maxR + 1
    for(int y = 0; y < n; ++y){
        for(int x = 0; x < m; ++x){
            if(board[y][x] == maxReachable){
                maxRy = y;
                maxRx = x;
            }
            if(board[y][x] == maxReachable + 1){
                maxR1y = y;
                maxR1x = x;
            }
        }
    }
   // cout << maxReachable << "  " << maxRy << " " << maxRx << endl;
    //cout << board[maxR1y][maxR1x] << "  " << maxR1y << " " << maxR1x << endl;
    // move maxR + 1 next to maxR
    if(maxRy - 1 >= 0){
        swap(board[maxR1y][maxR1x], board[maxRy - 1][maxRx]);
        if(findMaxReachable() == n * m + 1) ans++;
        swap(board[maxR1y][maxR1x], board[maxRy - 1][maxRx]);
    }
    if(maxRy + 1 < n){
        swap(board[maxR1y][maxR1x], board[maxRy + 1][maxRx]);
        if(findMaxReachable() == n * m + 1) ans++;
        swap(board[maxR1y][maxR1x], board[maxRy + 1][maxRx]);
    }
    if(maxRx - 1 >= 0){
        swap(board[maxR1y][maxR1x], board[maxRy][maxRx - 1]);
        if(findMaxReachable() == n * m + 1) ans++;
        swap(board[maxR1y][maxR1x], board[maxRy][maxRx - 1]);
    }
    if(maxRx + 1 < m){
        swap(board[maxR1y][maxR1x], board[maxRy][maxRx + 1]);
        if(findMaxReachable() == n * m + 1) ans++;
        swap(board[maxR1y][maxR1x], board[maxRy][maxRx + 1]);
    }
    // move maxR to maxR + 1
    if(maxR1y - 1 >= 0){
        swap(board[maxR1y - 1][maxR1x], board[maxRy][maxRx]);
        if(findMaxReachable() == n * m + 1) ans++;
        swap(board[maxR1y - 1][maxR1x], board[maxRy][maxRx]);
    }
    if(maxR1y + 1 < n){
        swap(board[maxR1y + 1][maxR1x], board[maxRy][maxRx]);
        if(findMaxReachable() == n * m + 1) ans++;
        swap(board[maxR1y + 1][maxR1x], board[maxRy][maxRx]);
    }
    if(maxR1x - 1 >= 0){
        swap(board[maxR1y][maxR1x - 1], board[maxRy][maxRx]);
        if(findMaxReachable() == n * m + 1) ans++;
        swap(board[maxR1y][maxR1x - 1], board[maxRy][maxRx]);
    }
    if(maxR1x + 1 < m){
        swap(board[maxR1y][maxR1x + 1], board[maxRy][maxRx]);
        if(findMaxReachable() == n * m + 1) ans++;
        swap(board[maxR1y][maxR1x + 1], board[maxRy][maxRx]);
    }
    if(ans == 0){
        cout << 2;
        return 0;
    }
    cout << 1 << " " << ans;
    return 0;
}
