#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << " "
#ifndef LOCAL
    #define cerr if (false) cerr
#endif

const int MAX_N = 1e5 + 10;
const int INF = 1e9 + 10;
const int MOD = 1e9;

int n;
int a[MAX_N];

bool check (){
    for (int i = 0; i < n; i ++) {
        if (a[i] != 1)return false;
    }
    return true;
}

void print (int x) {
    for (int i = 0; i < x; i ++) cerr << "\t";
}

long long solve (long long cnt) {
    print(cnt); cerr << out(cnt) << endl;
    print(cnt);
    for (int i = 0; i < n; i ++) {
        cerr << a[i] << " ";
    }
    cerr << endl;
    if (check ()) {
        return cnt;
    }
    long long ans = INF;
    for (int i = 0; i < n; i ++) {
        int currentGCD = a[i];
        for (int j = i; j < n; j ++) {
            if (__gcd(currentGCD, a[j]) <= 1) {
                break;
            }

            currentGCD = __gcd(currentGCD, a[j]);

            print(cnt); cerr << "Dividing from " << out(i) << "to " << out(j) << "by " << out(currentGCD) << endl;
            for (int x = i; x <= j; x ++) {
                a[x] /= currentGCD;
            }


            ans = min(ans, solve (cnt + 1));
            print(cnt); cerr << "Multiplying from " << out(i) << "to " << out(j) << "by " << out(currentGCD) << endl;
            for (int x = i; x <= j; x ++) {
                a[x] *= currentGCD;
            }
            print(cnt); for (int i = 0; i < n; i ++) {
                cerr << a[i] << " ";
            }
            cerr << endl;
        }
    }

    return ans;
}

int main () {
    #ifndef LOCAL
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    #endif

    int q;

    cin >> n >> q;

    for (int i = 0; i < n; i ++) {
        cin >> a[i];
    }

    cout << solve(0) << endl;

    return 0;
}
