# include <iostream>
# include <vector>
using namespace std;

const int MAXP=2e6+11,MAX=5e5+11;
int lp[MAXP];
vector<int> pr;

void Sieve()
{
    for(int i=2;i<MAXP;i++)
    {
        //cout<<i<<endl;

        if(lp[i]==0)
        {
            lp[i]=i;
            pr.push_back(i);
        }

        for(int j=0;j<(int)pr.size() and pr[j]*i<MAXP;j++)
        {
            lp[i*pr[j]]=pr[j];
            if(lp[i]==j) break;
        }
    }

    //for(int i=2;i<=64;i++) cout<<i<<":"<<lp[i]<<"\n";
    //cout<<pr.size()<<"\n";
}

int a[MAX];
int brd[MAX];
int n,q;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    Sieve();

    cin>>n>>q;
    for(int i=1;i<=n;i++) cin>>a[i];

    int ans=0;
    for(int i=1;i<=n;i++)
    {
        int x=a[i];
        int d=lp[x], br=0;
        while(x>1)
        {
            if(lp[x]==d) br++;
            else
            {
                if(brd[d]<br) ans+=br-brd[d];

                brd[d]=br;
                d=lp[x];
                br=1;
            }

            x/=d;
        }

        if(brd[d]<br) ans+=br-brd[d];
        brd[d]=br;
    }

    cout<<ans<<"\n";

    return 0;
}
