# include <iostream>
# include <vector>
using namespace std;

const long long MAXP=2e6+11,MAX=5e5+11;
long long lp[MAXP];
vector<long long> pr;

void Sieve()
{
    for(int i=2;i<MAXP;i++)
    {
        if(lp[i]==0)
        {
            for(int j=i;j<MAXP;j+=i) lp[j]=i;
        }
    }

    //for(long long i=2;i<=64;i++) cout<<i<<":"<<lp[i]<<"\n";
    //cout<<pr.size()<<"\n";
}

long long a[MAX];
long long brd[MAXP];
long long n,q;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    Sieve();

    cin>>n>>q;
    for(long long i=1;i<=n;i++) cin>>a[i];

    long long ans=0;
    for(long long i=1;i<=n;i++)
    {
        long long x=a[i];
        long long d=lp[x], br=0;
        while(x>1)
        {
            //cout<<x<<" ";

            if(lp[x]==d) br++;
            else
            {
                if(brd[d]<br) ans+=br-brd[d];

                brd[d]=br;
                d=lp[x];
                br=1;
            }

            x/=d;
        }
        //cout<<"\n";

        if(brd[d]<br) ans+=br-brd[d];
        brd[d]=br;
    }

    cout<<ans<<"\n";

    return 0;
}
