#include <bits/stdc++.h>
using namespace std;

const int MAXVALUE = 4 * 1e5 + 1;
int N, M;
vector<vector<int>> T;
pair<int, int> Position[MAXVALUE];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;
    T.resize(N);

    for(int i = 0; i < N; i++)
    {
        T[i].resize(M);

        for(int j = 0; j < M; j++)
        {
            cin >> T[i][j];
            Position[T[i][j]] = {i, j};
        }
    }
}

void Solve()
{
    if(N == 1)
    {
        vector<pair<int, int>> Swaps;

        for(int i = 0; i < M; i++)
        {
            if(i != T[0][i])
            {
                if(Position[i + 1].second == T[0][i])
                {
                    Swaps.push_back({T[0][i], i + 1});
                }
                else
                {
                    cout << 2;
                    return;
                }
            }
        }

        if((int)Swaps.size() > 2)
        {
            cout << 2;
            return;
        }

        if((int)Swaps.size() == 2)
        {
            cout << 1 << " " << 1;
            return;
        }

        cout << 0;
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

