#include <bits/stdc++.h>
using namespace std;

const int MAXVALUE = 2001;
int N, M;
vector<vector<int>> T;
vector<vector<int>> NewT;
vector<pair<int, int>> Position;
vector<pair<int, int>> NewP;
int DirsX[5] = {0, 0, - 1, 1};
int DirsY[5] = {-1, 1, 0, 0};
int Broken;
int C = 0;

bool Check()
{
    for(int i = 2; i <= N * M; i++)
    {
        bool Good = false;

        for(int Rotate = 0; Rotate < 4; Rotate++)
        {
            int X = Position[i].first + DirsX[Rotate];
            int Y = Position[i].second + DirsY[Rotate];

            if(X < 0 || X >= N || Y < 0 || Y >= M)
            {
                continue;
            }

            if(T[X][Y] < i)
            {
                Good = true;
                break;
            }
        }

        if(!Good)
        {
            if(C == 0)
            {
                Broken = i;
                C = 1;
            }
            return false;
        }
    }

    return true;
}

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;
    T.resize(N);
    Position.resize(N * M + 3);

    for(int i = 0; i < N; i++)
    {
        T[i].resize(M);

        for(int j = 0; j < M; j++)
        {
            cin >> T[i][j];
            Position[T[i][j]] = {i, j};
        }
    }
}

void Solve()
{
    if(Check())
    {
        cout << 0;
        return;
    }

    int Answer = 0;

    for(int i = 1; i <= N * M; i++)
    {
        for(int j = i + 1; j <= N * M; j++)
        {
            swap(T[Position[i].first][Position[i].second], T[Position[j].first][Position[j].second]);
            swap(Position[i], Position[j]);

            if(Check())
            {
                Answer++;
            }

            swap(Position[i], Position[j]);
            swap(T[Position[i].first][Position[i].second], T[Position[j].first][Position[j].second]);
        }
    }

    if(Answer > 0)
    {
        cout << 1 << " " << Answer;
        return;
    }

    cout << 2;
    return;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

