#include <bits/stdc++.h>
using namespace std;

int a[500001], sieve[2000001], degree[2000001];

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    for (int i = 1; i <= 2000000; i++) {
        for (int j = 2 * i; j <= 2000000; j += i) {
            sieve[j] = i;
        }
    }

    for (int i = 1; i <= 2000000; i++) {
        int num = i;

        while (num != 1) {
            num = sieve[num];
            degree[i]++;
        }
    }

    int br = 0;
    a[0] = 1;

    for (int i = 1; i <= n; i++) {
        br += degree[a[i] / __gcd(a[i], a[i - 1])];
    }

    cout << br << '\n';

    for (int query = 0; query < q; query++) {
        int i, j;
        cin >> i >> j;

        br -= degree[a[i] / __gcd(a[i], a[i - 1])];
        br -= degree[a[i + 1] / __gcd(a[i + 1], a[i])];

        a[i] = j;

        br += degree[a[i] / __gcd(a[i], a[i - 1])];
        br += degree[a[i + 1] / __gcd(a[i + 1], a[i])];

        cout << br << '\n';
    }

    return 0;

}
