#include <bits/stdc++.h>
#define int long long

using namespace std;
const int maxn = 1e5 + 5;
int a[maxn], n, q;
int gcd(int a, int b)
{
    if(b == 0)return a;
    return gcd(b, a%b);
}
int tree[4*maxn];
int globa;
void read()
{
    cin >> n >> q;
    for(int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }
}
void build(int l, int r, int idx)
{
    if(l == r)
    {
        tree[idx] = a[r];
        return;
    }
    int mid = l + (r - l)/2;
    build(l, mid, 2 * idx);
    build(mid+1, r, 2 * idx + 1);
    tree[idx] = gcd(tree[2*idx], tree[2*idx+1]);
}
int query(int l, int r, int ql, int qr, int idx)
{
    if(l > qr || ql > r)return 1;
    if(l == r)return tree[idx];
    int mid = l + (r - l)/2;
    int lq = query(l, mid, ql, qr, 2*idx);
    int rq = query(mid+1, r, ql, qr, 2*idx+1);
    if(rq != 1 && lq != 1)globa++;
    if(lq == 1 && rq != 1)return rq;
    else if(lq != 1 && rq == 1)return lq;
    else return gcd(lq, rq);
}
signed main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    build(1, n, 1);
    query(1, n, 1, n, 1);
    cout << globa << endl;
    return 0;
}
