#include <iostream>
#include <vector>
using namespace std;
#define maxA 2000000
#define maxN 500000
#define ll long long
#define st first
#define end first
#define val second
int divNum[maxA + 1];
int a[maxN + 1];
int primes[149000];
int n, q, primesCnt = 0;
vector<pair<int, int>> intSt[maxN + 1];
vector<pair<int, int>> intEnd[maxN + 1];
vector<pair<int, int>> curIntervals;

int gcd(int a, int b) {
    if (a < 0 || b < 0) {
        return -1;
    }
    if (b > a) {
        int temp = a;
        a = b;
        b = temp;
    }
    while (b != 0) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

void eratosten() {
    for (int i = 2; i <= maxA; i++) {
        if (divNum[i] == 0) {
            primes[primesCnt++] = i;
            for (int j = i; j <= maxA; j += i) {
                ll num = i;
                while (j % num == 0) {
                    divNum[j]++;
                    num *= i;
                }
            }
        }
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    eratosten();

    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    curIntervals.push_back(make_pair(0, a[0]));
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < curIntervals.size(); j++) {
            int res = gcd(a[i], curIntervals[j].val);
            if (res == -1) {
                continue;
            }
            if (res != curIntervals[j].val) {
                intSt[curIntervals[j].st].push_back( { i - 1, curIntervals[j].val / res } );
                intEnd[i - 1].push_back( { curIntervals[j].st, curIntervals[j].val / res } );
                if (res != 1) {
                    curIntervals[j].val = res;
                } else {
                    curIntervals[j].val = -1;
                }
            }
            a[i] /= res;
        }
        if (a[i] != 1) {
            curIntervals.push_back(make_pair(i, a[i]));
        }
    }
    for (int i = 0; i < curIntervals.size(); i++) {
        if (curIntervals[i].val >= 2) {
            intSt[curIntervals[i].st].push_back( { n - 1, curIntervals[i].val } );
            intEnd[n - 1].push_back( { curIntervals[i].st, curIntervals[i].val } );
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < intSt[i].size(); j++) {
            ans += divNum[intSt[i][j].val];
        }
    }
    cout << ans;
}
