#include <iostream>
#include <bitset>
using namespace std;

bitset<40002> visited[40002];
int a[400002];
int pos[400002];
int minNum = 2;
int cnt = 1;
int ans = 0;
int N;
int n;
int m;

bool checkIfSol(int idx) {
    visited[idx][pos[1]] = 1;
    for (int i = minNum; i <= N; i++) {
        bool up = visited[idx][pos[i] - m] || visited[0][pos[i] - m];
        bool down = visited[idx][pos[i] + m] || visited[0][pos[i] + m];
        bool left = visited[idx][pos[i] - 1] || visited[0][pos[i] - 1];
        bool right = visited[idx][pos[i] + 1] || visited[0][pos[i] + 1];
        if ((pos[i] != 0 && pos[i] % m != 0 && left) ||
            (pos[i] != N - 1 && pos[i] % m != m - 1 && right) ||
            (pos[i] + m < N && down) ||
            (pos[i] >= m && up)) {
            visited[idx][pos[i]] = 1;
        } else {
            return 0;
        }
    }
    return 1;
}

inline int getType(int f) {
    if (visited[0][f]) {
        return 1;
    }
    if ((f != 0 && f % m != 0 && visited[0][f - 1]) ||
        (f != N - 1 && f % m != m - 1 && visited[0][f + 1]) ||
        (f + m < N && visited[0][f + m]) ||
        (f >= m && visited[0][f - m])) {

        return 2;
    } else {
        return 3;
    }
}

void checkWithSwap(int a, int b) {
    if (a <= 0 || b <= 0 || a > N || b > N) {
        return;
    }
    int temp = pos[a];
    pos[a] = pos[b];
    pos[b] = temp;
    if (checkIfSol(cnt)) {
        ans++;
    }
    cnt++;
    temp = pos[a];
    pos[a] = pos[b];
    pos[b] = temp;
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    N = n * m;

    for (int i = 0; i < N; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    if (checkIfSol(0)) {
        cout << 0;
        return 0;
    }
    for (int i = 1; i <= N; i++) {
        if (!visited[0][pos[i]]) { minNum = i; break; }
    }
    for (int i = 1; i <= N; i++) {
        if (getType(pos[i]) == 2 && i != minNum) {
            checkWithSwap(i, minNum);
        }
    }
    if (minNum == 2) {
        if (pos[minNum] != N - 1) checkWithSwap(a[pos[minNum] + 1], 1);
        if (pos[minNum] != 0) checkWithSwap(a[pos[minNum] - 1], 1);
        if (pos[minNum] < N - m) checkWithSwap(a[pos[minNum] + m], 1);
        if (pos[minNum] >= m) checkWithSwap(a[pos[minNum] - m], 1);
    }
    for (int i = -1; i <= 1; i++) {
        for (int j = -1; j <= 1; j++) {
            if (abs(i) + abs(j) != 1) {
                continue;
            }
            int curPos = pos[minNum] + i + m * j;
            if (curPos < 0 || curPos >= N) {
                continue;
            }
            for (int k = 1; k <= N; k++) {
                if (getType(pos[k]) == 1 && k != a[curPos] && !(minNum == 2 && k == 1)) {
                    checkWithSwap(k, a[curPos]);
                }
            }
        }
    }
    if (ans == 0) {
        cout << "2";
    } else {
        cout << "1 " << ans;
    }
}
